abstract Route = Transport ** {
cat 
  Route; -- route description
  [Leg]{1};  -- a list of legs
  Leg;   -- route segment on a single line
  Line;  -- bus/tram line
  [Stop]{2}; -- list of at least two stops
fun 
  LegsRoute : [Leg] -> Route ;
  LineLeg : Line -> [Stop] -> Leg ;    -- leg on a line
  NamedLine : String -> Line ;        -- line labeled by a string
}